'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});
exports.mouseXY = mouseXY;
exports.startMouseEvent = startMouseEvent;

var _event = require('./event');

(0, _event.addHandler)('load', function (state) {
    window.addEventListener('focus', function () {
        return (0, _event.handle)(state, 'windowfocus');
    });
    window.addEventListener('blur', function () {
        return (0, _event.handle)(state, 'windowblur');
    });

    var resize = function resize(event) {
        return (0, _event.handle)(state, 'resize');
    };
    window.addEventListener('resize', resize);
    window.addEventListener('fullscreenchange', resize);

    document.addEventListener('visibilitychange', function () {
        if (document.hidden) {
            (0, _event.handle)(state, 'pagehide');
        } else {
            (0, _event.handle)(state, 'pageshow');
        }
    });
});

function mouseXY(event, component) {
    var x = event.pageX - (component.offsetLeft || 0);
    var y = event.pageY - (component.offsetTop || 0);
    return { x: x, y: y };
}

function startMouseEvent(state, name, component) {
    var skidEventName = arguments.length <= 3 || arguments[3] === undefined ? name : arguments[3];
    return (function () {
        component.addEventListener(name, function (event) {
            (0, _event.handle)(state, skidEventName, mouseXY(event, component));
        });
    })();
}

window.addEventListener('drop', function (event) {
    return event.preventDefault();
}, true);
window.addEventListener('dragover', function (event) {
    return event.preventDefault();
}, true);
//# sourceMappingURL=input.js.map
