'use strict';

var _Number$isFinite = require('babel-runtime/core-js/number/is-finite')['default'];

var _Number$isInteger = require('babel-runtime/core-js/number/is-integer')['default'];

var _Symbol$iterator = require('babel-runtime/core-js/symbol/iterator')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});
exports.isNumber = isNumber;
exports.isDefined = isDefined;
exports.isNullish = isNullish;
exports.isInteger = isInteger;
exports.isBoolean = isBoolean;
exports.isFunction = isFunction;
exports.isObject = isObject;
exports.isArray = isArray;
exports.isString = isString;
exports.isIterable = isIterable;
exports.isGeneratorFunction = isGeneratorFunction;
exports.isHash = isHash;

function isNumber(a) {
    return _Number$isFinite(a);
}

function isDefined(a) {
    return a != null;
}

function isNullish(a) {
    return a == null;
}

function isInteger(a) {
    return _Number$isInteger(a);
}

function isBoolean(a) {
    return !!a === a;
}

function isFunction(a) {
    return typeof a === 'function';
}

function isObject(a) {
    return typeof a === 'string' || !!a && typeof a === 'object';
}

function isArray(a) {
    return Array.isArray(a);
}

function isString(a) {
    return typeof a === 'string';
}

function isIterable(a) {
    return !!(a != null && a[_Symbol$iterator]);
}

function isGeneratorFunction(a) {
    return a != null && a.constructor.name === 'GeneratorFunction';
}

function isHash(a) {
    return !!a && typeof a === 'object' && !isArray(a);
}
//# sourceMappingURL=is.js.map
