'use strict';

var _Object$create = require('babel-runtime/core-js/object/create')['default'];

var _getIterator = require('babel-runtime/core-js/get-iterator')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});
exports.reset = reset;
exports.stateOf = stateOf;

var _event = require('./event');

var states = _Object$create(null);

function reset() {
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = _getIterator(_Object$keys(states)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var k = _step.value;

            delete states[k];
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator['return']) {
                _iterator['return']();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }
}

window.addEventListener('keydown', function (e) {
    var type = window.document.activeElement.type;
    if (type === 'textarea' || type === 'text' || type === 'password' || type === 'number') {
        // TODO: this doesn't account for holding the button while switching focus
        return;
    }

    states[e.keyCode] = true;
});
window.addEventListener('keyup', function (e) {
    states[e.keyCode] = false;
});

// TODO: use handler, not globals

function stateOf(keyCode) {
    return !!states[keyCode];
}

(0, _event.addHandler)('load_done', function (state) {
    window.addEventListener('keydown', function (event) {
        return onKey(state, event);
    });
    window.addEventListener('keyup', function (event) {
        return onKey(state, event);
    });
});

function onKey(state, event) {
    if (event.repeat) {
        return;
    }
    if (event.target.tagName === 'INPUT' || event.target.tagName === 'TEXTAREA') {
        if (event.code === 'Escape') {
            event.target.blur();
        }
        return;
    }
    (0, _event.handle)(state, 'key', event);
}
//# sourceMappingURL=keyboard.js.map
