"use strict";

var _createClass = require("babel-runtime/helpers/create-class")["default"];

var _classCallCheck = require("babel-runtime/helpers/class-call-check")["default"];

var _Object$create = require("babel-runtime/core-js/object/create")["default"];

var _Object$keys = require("babel-runtime/core-js/object/keys")["default"];

var _Symbol$iterator = require("babel-runtime/core-js/symbol/iterator")["default"];

var _regeneratorRuntime = require("babel-runtime/regenerator")["default"];

var _getIterator = require("babel-runtime/core-js/get-iterator")["default"];

Object.defineProperty(exports, "__esModule", {
    value: true
});

var MultiMap = (function () {
    function MultiMap() {
        _classCallCheck(this, MultiMap);

        this.data = _Object$create(null);
    }

    _createClass(MultiMap, [{
        key: "get",
        value: function get(key) {
            var result = this.data[key];
            if (!result) {
                result = [];
                this.data[key] = result;
            }
            return result;
        }
    }, {
        key: "add",
        value: function add(key, value) {
            this.get(key).push(value);
        }
    }, {
        key: "removeLast",
        value: function removeLast(key, value) {
            var arr = this.data[key];
            if (!arr) {
                return;
            }
            var index = arr.lastIndexOf(value);
            if (index === -1) {
                return;
            }
            if (arr.length === 1) {
                delete this.data[key];
            } else {
                arr.splice(index, 1);
            }
        }
    }, {
        key: "removeFirst",
        value: function removeFirst(key, value) {
            var arr = this.data[key];
            if (!arr) {
                return;
            }
            var index = arr.firstIndexOf(value);
            if (index === -1) {
                return;
            }
            if (arr.length === 1) {
                delete this.data[key];
            } else {
                arr.splice(index, 1);
            }
        }
    }, {
        key: "remove",
        value: function remove(key, value) {
            this.removeLast(key, value);
        }
    }, {
        key: "count",
        value: function count(key) {
            var arr = this.data[key];
            if (!arr) {
                return 0;
            }
            return arr.length;
        }

        /*
         * Does not support concurrent modification
         */
    }, {
        key: "forEachValue",
        value: function forEachValue(callback) {
            this.forEachMapping(function (key, arr) {
                return arr.forEach(callback);
            });
        }
    }, {
        key: "forEachMapping",
        value: function forEachMapping(callback) {
            var _this = this;

            _Object$keys(this.data).forEach(function (key) {
                var arr = _this.data[key];
                if (arr.length > 0) {
                    callback(key, arr);
                }
            });
        }
    }, {
        key: _Symbol$iterator,
        value: _regeneratorRuntime.mark(function value() {
            var key, arr, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, element;

            return _regeneratorRuntime.wrap(function value$(context$2$0) {
                while (1) switch (context$2$0.prev = context$2$0.next) {
                    case 0:
                        context$2$0.t0 = _regeneratorRuntime.keys(this.data);

                    case 1:
                        if ((context$2$0.t1 = context$2$0.t0()).done) {
                            context$2$0.next = 33;
                            break;
                        }

                        key = context$2$0.t1.value;
                        arr = this.data[key];

                        if (!(arr.length > 0)) {
                            context$2$0.next = 31;
                            break;
                        }

                        _iteratorNormalCompletion = true;
                        _didIteratorError = false;
                        _iteratorError = undefined;
                        context$2$0.prev = 8;
                        _iterator = _getIterator(arr);

                    case 10:
                        if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
                            context$2$0.next = 17;
                            break;
                        }

                        element = _step.value;
                        context$2$0.next = 14;
                        return element;

                    case 14:
                        _iteratorNormalCompletion = true;
                        context$2$0.next = 10;
                        break;

                    case 17:
                        context$2$0.next = 23;
                        break;

                    case 19:
                        context$2$0.prev = 19;
                        context$2$0.t2 = context$2$0["catch"](8);
                        _didIteratorError = true;
                        _iteratorError = context$2$0.t2;

                    case 23:
                        context$2$0.prev = 23;
                        context$2$0.prev = 24;

                        if (!_iteratorNormalCompletion && _iterator["return"]) {
                            _iterator["return"]();
                        }

                    case 26:
                        context$2$0.prev = 26;

                        if (!_didIteratorError) {
                            context$2$0.next = 29;
                            break;
                        }

                        throw _iteratorError;

                    case 29:
                        return context$2$0.finish(26);

                    case 30:
                        return context$2$0.finish(23);

                    case 31:
                        context$2$0.next = 1;
                        break;

                    case 33:
                    case "end":
                        return context$2$0.stop();
                }
            }, value, this, [[8, 19, 23, 31], [24,, 26, 30]]);
        })
    }]);

    return MultiMap;
})();

exports.MultiMap = MultiMap;
//# sourceMappingURL=multimap.js.map
