'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _group = require('./group');

var _interpolands = require('../interpolands');

var Camera = (function (_Group) {
    _inherits(Camera, _Group);

    function Camera(state, group) {
        _classCallCheck(this, Camera);

        if (!group) {
            group = state.skid.viewport.root;
        }
        if (!group) {
            throw new Error('initialize viewport before constructing camera');
        }
        _get(Object.getPrototypeOf(Camera.prototype), 'constructor', this).call(this, group);
        this.x = (0, _interpolands.makeInterpoland)(state, 0);
        this.y = (0, _interpolands.makeInterpoland)(state, 0);
        this.w = (0, _interpolands.makeInterpoland)(state, 0);
        this.h = (0, _interpolands.makeInterpoland)(state, 0);
        this.anchorX = (0, _interpolands.makeInterpoland)(state, 0);
        this.anchorY = (0, _interpolands.makeInterpoland)(state, 0);
        this.angle = (0, _interpolands.makeInterpoland)(state, 0);
        this.transform = undefined;
    }

    _createClass(Camera, [{
        key: 'subremove',
        value: function subremove() {
            this.x.remove();
            this.y.remove();
            this.w.remove();
            this.h.remove();
            this.anchorX.remove();
            this.anchorY.remove();
            this.angle.remove();
        }
    }, {
        key: 'draw',
        value: function draw(context) {
            var canvas = context.canvas;

            context.save();
            context.scale(canvas.width / this.w.curr, canvas.height / this.h.curr);

            var dx = -this.x.curr + this.w.curr * this.anchorX.curr;
            var dy = -this.y.curr + this.h.curr * this.anchorY.curr;
            if (dx || dy) {
                context.translate(dx, dy);
            }

            this.transform = DOMMatrix.fromMatrix(context.getTransform());

            _get(Object.getPrototypeOf(Camera.prototype), 'draw', this).call(this, context);

            context.restore();
        }
    }]);

    return Camera;
})(_group.Group);

exports.Camera = Camera;
//# sourceMappingURL=camera.js.map
