'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _slicedToArray = require('babel-runtime/helpers/sliced-to-array')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _avatar = require('./avatar');

var _is = require('../is');

var _array = require('../array');

function compare(a, b) {
    if ((0, _is.isNullish)(a._layer)) {
        return -1;
    }
    if ((0, _is.isNullish)(b._layer)) {
        return 1;
    }
    return b._layer - a._layer;
}

var Group = (function (_Avatar) {
    _inherits(Group, _Avatar);

    function Group(container) {
        _classCallCheck(this, Group);

        _get(Object.getPrototypeOf(Group.prototype), 'constructor', this).call(this, container);
        this.contents = [];
        this.visible = true;
    }

    _createClass(Group, [{
        key: 'walk',
        value: function walk(func) {
            func(this);
            this.walkContents(func);
        }
    }, {
        key: 'walkContents',
        value: function walkContents(callback) {
            for (var i = 0; i < this.contents.length; i += 1) {
                this.contents[i].walk(callback);
            }
        }
    }, {
        key: 'draw',
        value: function draw(context) {
            if (!this.visible) {
                return;
            }
            for (var i = 0; i < this.contents.length; i += 1) {
                this.contents[i].draw(context);
            }
        }
    }, {
        key: 'clear',
        value: function clear() {
            for (var i = 0; i < this.contents.length; i += 1) {
                this.contents[i].container = undefined;
                this.contents[i].remove();
            }
            this.contents.length = 0;
        }
    }, {
        key: 'subremove',
        value: function subremove() {
            for (var i = 0; i < this.contents.length; i += 1) {
                this.contents[i].container = undefined;
                this.contents[i].remove();
            }
            this.contents = undefined;
        }
    }, {
        key: 'bounds',
        value: function bounds() {
            var first = true;
            var left = undefined,
                top = undefined,
                right = undefined,
                bottom = undefined;
            this.walkContents(function (avatar) {
                var rect = avatar.bounds();
                if (!rect) {
                    return;
                }

                var _rect = _slicedToArray(rect, 4);

                var left2 = _rect[0];
                var top2 = _rect[1];
                var width2 = _rect[2];
                var height2 = _rect[3];

                var right2 = left2 + width2;
                var bottom2 = top2 + height2;

                if (first) {
                    first = false;left = left2;
                    top = top2;
                    right = right2;
                    bottom = bottom2;

                    return;
                }

                left = Math.min(left, left2);
                top = Math.min(top, top2);
                right = Math.max(right, right2);
                bottom = Math.max(bottom, bottom2);
            });
            if (first) {
                return undefined;
            }

            return [left, top, right - left, bottom - top];
        }
    }, {
        key: 'insert',
        value: function insert(avatar) {
            avatar.container = this;
            (0, _array.insertSorted)(this.contents, avatar, compare);
        }
    }, {
        key: 'resort',
        value: function resort(avatar) {
            // TODO: bubble sort to avoid allocation?
            (0, _array.remove)(this.contents, avatar);
            (0, _array.insertSorted)(this.contents, avatar, compare);
        }
    }, {
        key: 'removeAvatar',
        value: function removeAvatar(avatar) {
            (0, _array.remove)(this.contents, avatar);
        }
    }, {
        key: 'empty',
        get: function get() {
            return this.contents.length === 0;
        }
    }]);

    return Group;
})(_avatar.Avatar);

exports.Group = Group;
//# sourceMappingURL=group.js.map
