'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _avatar = require('./avatar');

var _turns = require('../turns');

var _interpolands = require('../interpolands');

var PieAvatar = (function (_Avatar) {
    _inherits(PieAvatar, _Avatar);

    function PieAvatar(state, container) {
        _classCallCheck(this, PieAvatar);

        _get(Object.getPrototypeOf(PieAvatar.prototype), 'constructor', this).call(this, container);
        this.x = (0, _interpolands.makeInterpoland)(state, 0);
        this.y = (0, _interpolands.makeInterpoland)(state, 0);
        this.w = (0, _interpolands.makeInterpoland)(state, 0);
        this.h = (0, _interpolands.makeInterpoland)(state, 0);
        // Distance of second jaw from first jaw. Positive is clockwise.
        // 0 = nothing rendered. 1 = full circle.
        this.breadth = (0, _interpolands.makeInterpoland)(state, 0);
        // Distance of first jaw from north. Positive is clockwise.
        this.startAngle = (0, _interpolands.makeInterpoland)(state, 0);
        this.innerRadiusRel = (0, _interpolands.makeInterpoland)(state, 0);
        this.fillStyle = undefined;
        this.strokeStyle = undefined;
        this.lineWidth = undefined;
    }

    _createClass(PieAvatar, [{
        key: 'draw',
        value: function draw(context) {
            if (this.breadth.curr === 0) {
                return;
            }

            context.save();
            if (this.x.curr || this.y.curr) {
                context.translate(this.x.curr, this.y.curr);
            }
            if (this.w.curr !== 1 || this.h.curr !== 1) {
                context.scale(this.w.curr, this.h.curr);
            }

            context.beginPath();

            if (this.breadth.curr >= 1 && this.innerRadiusRel.curr >= 1) {
                context.arc(0, 0, 0.5, 0, Math.PI * 2, false);
            } else {
                var startAngle = this.startAngle.curr;
                var endAngle = startAngle + this.breadth.curr;

                startAngle = (0, _turns.toRadians)(startAngle - 0.25);
                endAngle = (0, _turns.toRadians)(endAngle - 0.25);

                context.arc(0, 0, 0.5 * this.innerRadiusRel.curr, endAngle, startAngle, this.breadth.curr >= 0);
                context.arc(0, 0, 0.5, startAngle, endAngle, this.breadth.curr < 0);
            }

            context.closePath();

            if (this.fillStyle) {
                context.fillStyle = this.fillStyle;
                context.fill();
            }
            if (this.strokeStyle && this.lineWidth) {
                context.strokeStyle = this.strokeStyle;
                context.lineWidth = this.lineWidth;
                context.stroke();
            }

            context.restore();
        }
    }, {
        key: 'subremove',
        value: function subremove() {
            this.x.remove();
            this.y.remove();
            this.w.remove();
            this.h.remove();
            this.breadth.remove();
            this.startAngle.remove();
            this.innerRadiusRel.remove();
        }
    }]);

    return PieAvatar;
})(_avatar.Avatar);

exports.PieAvatar = PieAvatar;
//# sourceMappingURL=pieavatar.js.map
