'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _avatar = require('./avatar');

var _interpolands = require('../interpolands');

var _turns = require('../turns');

var RectAvatar = (function (_Avatar) {
    _inherits(RectAvatar, _Avatar);

    function RectAvatar(state, container) {
        _classCallCheck(this, RectAvatar);

        _get(Object.getPrototypeOf(RectAvatar.prototype), 'constructor', this).call(this, container);
        this.x = (0, _interpolands.makeInterpoland)(state, 0);
        this.y = (0, _interpolands.makeInterpoland)(state, 0);
        this.w = (0, _interpolands.makeInterpoland)(state, 0);
        this.h = (0, _interpolands.makeInterpoland)(state, 0);
        this.angle = (0, _interpolands.makeInterpoland)(state, 0);
        this.anchorX = (0, _interpolands.makeInterpoland)(state, 0);
        this.anchorY = (0, _interpolands.makeInterpoland)(state, 0);
        this.fillStyle = undefined;
        this.strokeStyle = undefined;
        this.lineWidth = undefined;
        this.radius = undefined;
    }

    _createClass(RectAvatar, [{
        key: 'draw',
        value: function draw(context) {
            if (!this.w.curr || !this.h.curr) {
                return;
            }

            context.save();
            if (this.x.curr || this.y.curr) {
                context.translate(this.x.curr, this.y.curr);
            }
            if (this.angle.curr) {
                context.rotate((0, _turns.toRadians)(this.angle.curr));
            }
            if (this.anchorX.curr || this.anchorY.curr) {
                context.translate(-this.w.curr * this.anchorX.curr, -this.h.curr * this.anchorY.curr);
            }

            if (this.radius) {
                doRoundRectPath(context, 0, 0, this.w.curr, this.h.curr, this.radius);
            }

            if (this.fillStyle) {
                context.fillStyle = this.fillStyle;
                if (this.radius) {
                    context.fill();
                } else {
                    context.fillRect(0, 0, this.w.curr, this.h.curr);
                }
            }
            if (this.strokeStyle) {
                context.strokeStyle = this.strokeStyle;
                context.lineWidth = this.lineWidth;
                if (this.radius) {
                    context.stroke();
                } else {
                    context.strokeRect(0, 0, this.w.curr, this.h.curr);
                }
            }

            context.restore();
        }
    }, {
        key: 'subremove',
        value: function subremove() {
            this.x.remove();
            this.y.remove();
            this.w.remove();
            this.h.remove();
            this.angle.remove();
            this.anchorX.remove();
            this.anchorY.remove();
        }
    }]);

    return RectAvatar;
})(_avatar.Avatar);

exports.RectAvatar = RectAvatar;

function doRoundRectPath(context, x, y, w, h, radius) {
    context.beginPath();
    context.moveTo(x + radius, y);
    context.lineTo(x + w - radius, y);
    context.quadraticCurveTo(x + w, y, x + w, y + radius);
    context.lineTo(x + w, y + h - radius);
    context.quadraticCurveTo(x + w, y + h, x + w - radius, y + h);
    context.lineTo(x + radius, y + h);
    context.quadraticCurveTo(x, y + h, x, y + h - radius);
    context.lineTo(x, y + radius);
    context.quadraticCurveTo(x, y, x + radius, y);
    context.closePath();
}
//# sourceMappingURL=rectavatar.js.map
