'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _group = require('./group');

var _is = require('../is');

var _interpolands = require('../interpolands');

var Scalement = (function (_Group) {
    _inherits(Scalement, _Group);

    function Scalement(state, container, w, h) {
        _classCallCheck(this, Scalement);

        _get(Object.getPrototypeOf(Scalement.prototype), 'constructor', this).call(this, container);
        if (!(0, _is.isDefined)(w)) {
            w = 1;
        }
        if (!(0, _is.isDefined)(h)) {
            h = 1;
        }
        this.w = (0, _interpolands.makeInterpoland)(state, w);
        this.h = (0, _interpolands.makeInterpoland)(state, h);
    }

    _createClass(Scalement, [{
        key: 'draw',
        value: function draw(context) {
            if (this.empty || !this.w.curr || !this.h.curr) {
                return;
            }

            if (this.w.curr !== 1 || this.h.curr !== 1) {
                context.scale(this.w.curr, this.h.curr);
            }

            _get(Object.getPrototypeOf(Scalement.prototype), 'draw', this).call(this, context);

            if (this.w.curr !== 1 || this.h.curr !== 1) {
                context.scale(1 / this.w.curr, 1 / this.h.curr);
            }
        }
    }, {
        key: 'subremove',
        value: function subremove() {
            this.w.remove();
            this.h.remove();
        }
    }, {
        key: 'bounds',
        value: function bounds() {
            console.warn('Not implemented'); // TODO
        }
    }], [{
        key: 'draw',
        value: function draw(context, w, h, impl) {
            if (!w || !h) {
                return;
            }
            if (w !== 1 || h !== 1) {
                context.scale(w, h);
            }

            impl(context);

            if (w !== 1 || h !== 1) {
                context.scale(1 / w, 1 / h);
            }
        }
    }]);

    return Scalement;
})(_group.Group);

exports.Scalement = Scalement;
//# sourceMappingURL=scalement.js.map
