'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _avatar = require('./avatar');

var _is = require('../is');

var _interpolands = require('../interpolands');

var TextAvatar = (function (_Avatar) {
    _inherits(TextAvatar, _Avatar);

    function TextAvatar(state, container, camera) {
        _classCallCheck(this, TextAvatar);

        _get(Object.getPrototypeOf(TextAvatar.prototype), 'constructor', this).call(this, container);
        this.x = (0, _interpolands.makeInterpoland)(state, 0);
        this.y = (0, _interpolands.makeInterpoland)(state, 0);
        this.camera = camera;
        this.font = undefined;
        this.text = '';
        this.textAlign = 'center'; // options: center, left, right
        this.textBaseline = 'middle'; // options: middle, top, bottom
        this.fillStyle = undefined; // example: 'black'
        this.strokeStyle = undefined;
        this.lineWidth = undefined;
    }

    _createClass(TextAvatar, [{
        key: 'draw',
        value: function draw(context) {
            var canvas = context.canvas;
            var cw = canvas.width;
            var ch = canvas.height;

            context.save();

            if ((0, _is.isFunction)(this.font)) {
                context.font = this.font(cw, ch);
            } else {
                context.font = this.font;
            }

            if (this.x.curr || this.y.curr) {
                context.translate(this.x.curr, this.y.curr);
            }

            if (this.camera) {
                context.scale(1 / (cw / this.camera.w.curr), 1 / (ch / this.camera.h.curr));
            }

            context.textAlign = this.textAlign;
            context.textBaseline = this.textBaseline;

            if (this.strokeStyle) {
                if ((0, _is.isFunction)(this.lineWidth)) {
                    context.lineWidth = this.lineWidth(cw, ch);
                } else {
                    context.lineWidth = this.lineWidth;
                }
                context.strokeStyle = this.strokeStyle;
                context.strokeText(this.text, 0, 0);
            }
            if (this.fillStyle) {
                context.fillStyle = this.fillStyle;
                context.fillText(this.text, 0, 0);
            }

            context.restore();
        }
    }]);

    return TextAvatar;
})(_avatar.Avatar);

exports.TextAvatar = TextAvatar;
//# sourceMappingURL=textavatar.js.map
