'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});
exports.handleLater = handleLater;
exports.handleInterval = handleInterval;
exports.procrastinate = procrastinate;
exports.callLater = callLater;

var _event = require('./event');

function handleLater(state, delay, code, arg) {
    return callLater(state, delay, _event.handle, state, code, arg);
}

function handleInterval(state, delay, code, arg) {
    var timeout = undefined;
    function trigger() {
        (0, _event.handle)(state, code, arg);
        timeout = callLater(state, delay, trigger);
    }
    timeout = callLater(state, delay, trigger);
    return { stop: function stop() {
            return clearTimeout(timeout);
        } };
}

function procrastinate(inCode, outCode, delay) {
    var timeout = undefined;
    (0, _event.addHandler)(inCode, function (state) {
        clearTimeout(timeout);
        timeout = handleLater(state, delay, outCode);
    });
}

function callingLater(state, callback, targetTime, a, b, c, d) {
    state.skid.timeRemainder = Math.min(100, Date.now() - targetTime);
    callback(a, b, c, d);
    state.skid.timeRemainder = 0;
}

function callLater(state, delay, callback, a, b, c, d) {
    if (!state.skid.timeRemainder) {
        state.skid.timeRemainder = 0;
    }
    var targetTime = Date.now() + delay - state.skid.timeRemainder;

    return setTimeout(callingLater, delay - state.skid.timeRemainder, state, callback, targetTime, a, b, c, d);
}
//# sourceMappingURL=timer.js.map
