"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.zero = zero;
exports.one = one;
exports.linear = linear;
exports.powerFac = powerFac;
exports.quadratic = quadratic;
exports.quadraticInOut = quadraticInOut;
exports.cubic = cubic;
exports.quartic = quartic;
exports.sine = sine;
exports.sine2 = sine2;
exports.sine3 = sine3;
exports.cosine = cosine;
exports.circle = circle;
exports.reverseSine = reverseSine;

function zero(x) {
    return Math.floor(x);
}

function one(x) {
    return Math.ceil(x);
}

function linear(x) {
    return x;
}

function powerFac(exp) {
    if (exp === 1) {
        return linear;
    }
    return function (x) {
        return Math.pow(x, exp);
    };
}

function quadratic(x) {
    return x * x;
}

function quadraticInOut(x) {
    x *= 2;
    if (x < 1) {
        return x * x / 2;
    }
    x -= 1;
    return -1 / 2 * (x * (x - 2) - 1);
}

function cubic(x) {
    return x * x * x;
}

function quartic(x) {
    return x * x * x * x;
}

function sine(x) {
    return Math.sin(x * Math.PI / 2);
}

function sine2(x) {
    return sine(sine(x));
}

function sine3(x) {
    return sine(sine(sine(x)));
}

function cosine(x) {
    return (1 - Math.cos(x * Math.PI)) / 2;
}

function circle(x) {
    return Math.sqrt(1 - Math.pow(x - 1, 2));
}

function reverseSine(x) {
    return 1 - Math.sin((x + 1) * Math.PI / 2);
}
//# sourceMappingURL=tween.js.map
