'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});
exports.sine = sine;
exports.quake = quake;

function sine(cycles) {
    if (Math.floor(cycles * 2) !== cycles * 2) {
        throw new Error('number of cycles must be multiple of .5');
    }
    return function (x) {
        return Math.sin(x * Math.PI * 2 * cycles);
    };
}

function quake(cycles) {
    var subFunc = sine(cycles);
    return function (x) {
        return (1 - x) * subFunc(x);
    };
}
//# sourceMappingURL=tweeninplace.js.map
