'use strict';

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});
exports.zero = zero;
exports.distance = distance;
exports.distanceXY = distanceXY;
exports.distance4XY = distance4XY;
exports.distance8XY = distance8XY;
exports.rotatedXYTurns = rotatedXYTurns;
exports.rotatedXYRadians = rotatedXYRadians;

var _turns = require('./turns');

var Vec2 = (function () {
    function Vec2(x, y) {
        _classCallCheck(this, Vec2);

        this.x = x;
        this.y = y;
    }

    _createClass(Vec2, [{
        key: 'equals',
        value: function equals(obj) {
            return obj && this.x === obj.x && this.y === obj.y;
        }
    }, {
        key: 'hashCode',
        value: function hashCode() {
            return this.x << 8 | this.y;
        }
    }, {
        key: 'sum',
        value: function sum(other) {
            return this.sumXY(other.x, other.y);
        }
    }, {
        key: 'sumXY',
        value: function sumXY(x, y) {
            return new Vec2(this.x + x, this.y + y);
        }
    }, {
        key: 'distance4',
        value: function distance4(other) {
            return distance4XY(this.x, this.y, other.x, other.y);
        }
    }, {
        key: 'distance8',
        value: function distance8(other) {
            return distance8XY(this.x, this.y, other.x, other.y);
        }
    }, {
        key: 'rotatedTurns',
        value: function rotatedTurns(angle) {
            return rotatedXYTurns(this.x, this.y, angle);
        }
    }, {
        key: 'rotatedRadians',
        value: function rotatedRadians(angle) {
            return rotatedXYRadians(this.x, this.y, angle);
        }
    }, {
        key: 'toString',
        value: function toString() {
            return this.x + ',' + this.y;
        }
    }, {
        key: 'inverse',
        get: function get() {
            return new Vec2(-this.x, -this.y);
        }
    }]);

    return Vec2;
})();

exports.Vec2 = Vec2;

function zero() {
    return new Vec2(0, 0);
}

function distance(a, b) {
    var x = a.x - b.x;
    var y = a.y - b.y;
    return Math.sqrt(x * x + y * y);
}

// TODO: distanceSqXY

function distanceXY(x1, y1, x2, y2) {
    return Math.sqrt(Math.pow(x1 - x2, 2) + Math.pow(y1 - y2, 2));
}

function distance4XY(x1, y1, x2, y2) {
    return Math.abs(x1 - x2) + Math.abs(y1 - y2);
}

function distance8XY(x1, y1, x2, y2) {
    return Math.max(Math.abs(x1 - x2), Math.abs(y1 - y2));
}

function rotatedXYTurns(x, y, angle) {
    return rotatedXYRadians(x, y, (0, _turns.toRadians)(angle));
}

function rotatedXYRadians(x, y, angle) {
    var s = Math.sin(angle);
    var c = Math.cos(angle);
    return new Vec2(x * c - y * s, x * s + y * c);
}
//# sourceMappingURL=vector2.js.map
